PHP DIY 系列------基础篇:2. Composer


上一节我们介绍了我们需要遵循的规范,这一节我们来介绍一下我们的项目中需要用到的一个依赖管理工具——Composer。

Composer 是 PHP 的一个依赖管理工具。它允许你申明项目所依赖的代码库,它会在你的项目中为你安装他们。

image

如果你是前端工程师,你应该用过npm;如果你是pyhton开发者,你应该用过pip,简单说你可以这样理解composer。

composer在小册中可能经常会被提及,我们来学习一下安装和常用命令。

安装

  1. Linux

composer的安装比较简单,不建议使用yum等管理包直接install,因为有可能会修改你的默认php版本。我们可以跳过以下方式安装:

curl -sS https://getcomposer.org/installer | php

mv composer.phar /usr/local/bin/composer

  1. Windows

下载并且运行 Composer-Setup.exe,它将安装最新版本的 Composer ,建议加入系统的环境变量,这样你就可以在任何目录下直接使用 composer 命令。

修改镜像源

默认镜像源国内下载比较慢,建议更换镜像源

composer config -g repo.packagist composer https://packagist.phpcomposer.com

也可以使用阿里的镜像源(推荐)

composer config -g repo.packagist composer https://mirrors.aliyun.com/composer/

config -g/–global 表示全局配置

composer常用命令

init初始化

参数:
--name: 包的名称。
--description: 包的描述。
--author: 包的作者。
--homepage: 包的主页。
--require: 需要依赖的其它包,必须要有一个版本约束。并且应该遵循 foo/bar:1.0.0 这样的格式。
--require-dev: 开发版的依赖包,内容格式与 --require 相同。
--stability (-s): minimum-stability 字段的值。

require增加

require 命令增加新的依赖包到当前目录的 composer.json 文件中,并可以指定版本。

composer require vendor/package:2.* vendor/package2:dev-master

install安装

install 命令从当前目录读取 composer.json 文件,处理了依赖关系,并把其安装到 vendor 目录下。

如果当前目录下存在 composer.lock 文件,它会从此文件读取依赖版本,而不是根据 composer.json 文件去获取依赖。这确保了该库的每个使用者都能得到相同的依赖版本。

如果没有 composer.lock 文件,composer 将在处理完依赖关系后创建它。

你可以简单把composer.lock理解为扩展库的缓存。

update更新

为了获取依赖的最新版本,并且更新 composer.lock 文件,你应该使用 update 命令。

composer update

这将解决项目的所有依赖,并将确切的版本号写入 composer.lock。

如果你只是想更新几个包,你可以像这样分别列出它们:

composer update vendor/package vendor/package2

==注意==:update命令会更新composer.json里限定版本的最新依赖。
比如你写的是”monolog/monolog”: “1.*”,update命令可能会把1.0更新为1.2版本,但不会将1.0更新为2.0。所以使用时需要注意。

search

search 命令允许你为当前项目搜索依赖包,通常它只搜索 packagist.org 上的包,你可以简单的输入你的搜索条件。

show

列出所有可用的软件包,你可以使用 show 命令。

composer-show

也可以点击查看更多composer包

dump-autoload

打印自动加载索引,某些情况下你需要更新 autoloader,例如在你的包中加入了一个新的类。你可以使用 dump-autoload 来完成,而不必执行 install 或 update 命令。

此外,它可以打印一个优化过的,符合 PSR-0/4 规范的类的索引,这也是出于对性能的可考虑。在大型的应用中会有许多类文件,而 autoloader 会占用每个请求的很大一部分时间,使用 classmaps 或许在开发时不太方便,但它在保证性能的前提下,仍然可以获得 PSR-0/4 规范带来的便利。

更composer多命令请点击查看


好了,这一节我们介绍了composer的安装和常用命令。我们后面可以将框架集成到一个composer包,分享给其他开发同学使用。

php
本作品采用《CC 协议》,转载必须注明作者和本文链接

收藏前不妨点个赞试试!!!
分享开发知识,欢迎交流。qq957042781,公众号:爱好历史的程序员。
点击直达个人博客

讨论数量: 0
(= ̄ω ̄=)··· 暂无内容!

请勿发布不友善或者负能量的内容。与人为善,比聪明更重要!